Index: code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/Planet.cc	(revision 2908)
@@ -42,5 +42,5 @@
 #include "CameraManager.h"
 #include "Camera.h"
-#include "GraphicsManager.h"
+#include "GraphicsEngine.h"
 
 namespace orxonox
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2908)
@@ -181,5 +181,5 @@
 
         // Attach to parent if necessary
-        registerVariable(this->parentID_,       variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::networkcallback_parentChanged));
+        registerVariable(this->parentID_,       variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::parentChanged));
     }
 
@@ -188,5 +188,5 @@
         Network function that object this instance to its correct parent.
     */
-    void WorldEntity::networkcallback_parentChanged()
+    void WorldEntity::parentChanged()
     {
         if (this->parentID_ != OBJECTID_UNKNOWN)
@@ -362,11 +362,9 @@
         this->parentID_ = newParent->getObjectID();
 
-        this->parentChanged();
-
         // apply transform to collision shape
         this->collisionShape_->setPosition(this->getPosition());
         this->collisionShape_->setOrientation(this->getOrientation());
         // TODO: Scale
-
+        
         return true;
     }
@@ -408,6 +406,4 @@
         this->parent_ = 0;
         this->parentID_ = OBJECTID_UNKNOWN;
-
-        this->parentChanged();
 
         // reset orientation of the collisionShape (cannot be set within a WE usually)
@@ -492,5 +488,5 @@
 
     // Note: These functions are placed in WorldEntity.h as inline functions for the release build.
-#ifndef NDEBUG
+#ifndef _NDEBUG
     const Vector3& WorldEntity::getPosition() const
     {
@@ -660,5 +656,4 @@
         case TransformSpace::World:
             ogreRelativeTo = Ogre::Node::TS_WORLD; break;
-        default: OrxAssert(false, "Faulty TransformSpace::Enum assigned.");
         }
         this->node_->setDirection(direction, ogreRelativeTo, localDirectionVector);
@@ -760,5 +755,5 @@
         {
         case Dynamic:
-            this->physicalBody_->setCollisionFlags(this->physicalBody_->getCollisionFlags() & !btCollisionObject::CF_STATIC_OBJECT & !btCollisionObject::CF_KINEMATIC_OBJECT);
+            this->physicalBody_->setCollisionFlags(this->physicalBody_->getCollisionFlags() & !(btCollisionObject::CF_STATIC_OBJECT | btCollisionObject::CF_KINEMATIC_OBJECT));
             break;
         case Kinematic:
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2908)
@@ -33,5 +33,5 @@
 #include "OrxonoxPrereqs.h"
 
-#ifdef NDEBUG
+#ifdef _NDEBUG
 #include <OgreSceneNode.h>
 #else
@@ -176,6 +176,4 @@
 
         protected:
-            virtual void parentChanged() {}
-
             Ogre::SceneNode* node_;
 
@@ -193,5 +191,5 @@
 
             // network callbacks
-            void networkcallback_parentChanged();
+            void parentChanged();
             inline void scaleChanged()
                 { this->setScale3D(this->getScale3D()); }
@@ -271,5 +269,5 @@
             @brief
                 Sets how much reaction is applied in a collision.
-
+                
                 Consider two equal spheres colliding with equal velocities:
                 Restitution 1 means that both spheres simply reverse their velocity (no loss of energy)
@@ -421,9 +419,9 @@
 
     // Inline heavily used functions for release builds. In debug, we better avoid including OgreSceneNode here.
-#ifdef NDEBUG
+#ifdef _NDEBUG
     inline const Vector3& WorldEntity::getPosition() const
         { return this->node_->getPosition(); }
     inline const Quaternion& WorldEntity::getOrientation() const
-        { return this->node_->getOrientation(); }
+        { return this->node_->getrOrientation(); }
     inline const Vector3& WorldEntity::getScale3D(void) const
         { return this->node_->getScale(); }
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 2908)
@@ -30,5 +30,5 @@
 #include "Pawn.h"
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -63,5 +63,5 @@
         this->getPickUp().setPlayer(this);
 
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             this->weaponSystem_ = new WeaponSystem(this);
@@ -133,20 +133,4 @@
     }
 
-    void Pawn::setPlayer(PlayerInfo* player)
-    {
-        ControllableEntity::setPlayer(player);
-
-        if (this->getGametype())
-            this->getGametype()->playerStartsControllingPawn(player, this);
-    }
-
-    void Pawn::removePlayer()
-    {
-        if (this->getGametype())
-            this->getGametype()->playerStopsControllingPawn(this->getPlayer(), this);
-
-        ControllableEntity::removePlayer();
-    }
-
     void Pawn::setHealth(float health)
     {
@@ -156,22 +140,16 @@
     void Pawn::damage(float damage, Pawn* originator)
     {
-        if (this->getGametype() && this->getGametype()->allowPawnDamage(this, originator))
-        {
-            this->setHealth(this->health_ - damage);
-            this->lastHitOriginator_ = originator;
-
-            // play damage effect
-        }
+        this->setHealth(this->health_ - damage);
+        this->lastHitOriginator_ = originator;
+
+        // play damage effect
     }
 
     void Pawn::hit(Pawn* originator, const Vector3& force, float damage)
     {
-        if (this->getGametype() && this->getGametype()->allowPawnHit(this, originator))
-        {
-            this->damage(damage, originator);
-            this->setVelocity(this->getVelocity() + force);
-
-            // play hit effect
-        }
+        this->damage(damage, originator);
+        this->setVelocity(this->getVelocity() + force);
+
+        // play hit effect
     }
 
@@ -198,22 +176,17 @@
     void Pawn::death()
     {
-        if (this->getGametype() && this->getGametype()->allowPawnDeath(this, this->lastHitOriginator_))
-        {
-            // Set bAlive_ to false and wait for PawnManager to do the destruction
-            this->bAlive_ = false;
-
-            this->setDestroyWhenPlayerLeft(false);
-
-            if (this->getGametype())
-                this->getGametype()->pawnKilled(this, this->lastHitOriginator_);
-
-            if (this->getPlayer())
-                this->getPlayer()->stopControl(this);
-
-            if (GameMode::isMaster())
-                this->deatheffect();
-        }
-        else
-            this->setHealth(1);
+        // Set bAlive_ to false and wait for PawnManager to do the destruction
+        this->bAlive_ = false;
+
+        this->setDestroyWhenPlayerLeft(false);
+
+        if (this->getGametype())
+            this->getGametype()->pawnKilled(this, this->lastHitOriginator_);
+
+        if (this->getPlayer())
+            this->getPlayer()->stopControl(this);
+
+        if (Core::isMaster())
+            this->deatheffect();
     }
 
@@ -249,4 +222,5 @@
             ExplosionChunk* chunk = new ExplosionChunk(this->getCreator());
             chunk->setPosition(this->getPosition());
+
         }
     }
@@ -260,5 +234,5 @@
     {
         this->setHealth(this->initialHealth_);
-        if (GameMode::isMaster())
+        if (Core::isMaster())
             this->spawneffect();
     }
@@ -269,10 +243,4 @@
     }
 
-
-    /* WeaponSystem:
-    *   functions load Slot, Set, Pack from XML and make sure all parent-pointers are set.
-    *   with setWeaponPack you can not just load a Pack from XML but if a Pack already exists anywhere, you can attach it.
-    *       --> e.g. Pickup-Items
-    */
     void Pawn::setWeaponSlot(WeaponSlot * wSlot)
     {
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Pawn.h	(revision 2908)
@@ -47,7 +47,4 @@
             virtual void tick(float dt);
             void registerVariables();
-
-            virtual void setPlayer(PlayerInfo* player);
-            virtual void removePlayer();
 
             inline bool isAlive() const
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Spectator.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2908)
@@ -34,5 +34,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "objects/worldentities/Model.h"
 #include "objects/Scene.h"
@@ -63,5 +63,5 @@
         this->setDestroyWhenPlayerLeft(true);
 
-        if (GameMode::showsGraphics())
+        if (Core::showsGraphics())
         {
             this->greetingFlare_ = new BillboardSet();
@@ -206,5 +206,5 @@
         this->bGreeting_ = !this->bGreeting_;
 
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             this->bGreetingFlareVisible_ = this->bGreeting_;
Index: code/branches/questsystem5/src/orxonox/objects/worldentities/triggers/Trigger.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2908)
@@ -36,5 +36,5 @@
 #include "core/ConsoleCommand.h"
 #include "core/XMLPort.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "objects/Scene.h"
 
@@ -67,5 +67,5 @@
 //    this->bUpdating_ = false;
 
-    if (this->getScene() && GameMode::showsGraphics())
+    if (this->getScene() && Core::showsGraphics())
     {
       this->debugBillboard_.setBillboardSet(this->getScene()->getSceneManager(), "Examples/Flare", ColourValue(1.0, 0.0, 0.0), 1);
Index: code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 2908)
@@ -39,14 +39,11 @@
 #include <OgreOverlayManager.h>
 #include <OgrePanelOverlayElement.h>
-#include <OgreRenderWindow.h>
-
 #include "util/Convert.h"
 #include "util/Exception.h"
 #include "util/String.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
 #include "core/ConsoleCommand.h"
-#include "GraphicsManager.h"
 
 namespace orxonox
@@ -67,5 +64,5 @@
         this->group_ = 0;
 
-        if (!GameMode::showsGraphics())
+        if (!Core::showsGraphics())
             ThrowException(NoGraphics, "Can't create OrxonoxOverlay, graphics engine not initialized");
 
@@ -80,7 +77,7 @@
         this->overlay_->add2D(this->background_);
 
-        // Get aspect ratio from the render window. Later on, we get informed automatically
-        Ogre::RenderWindow* defaultWindow = GraphicsManager::getInstance().getRenderWindow();
-        this->windowAspectRatio_ = (float)defaultWindow->getWidth() / defaultWindow->getHeight();
+        // We'll have to set the aspect ratio to a default value first.
+        // GSGraphics gets informed about our construction here and can update us in the next tick.
+        this->windowAspectRatio_ = 1.0;
         this->sizeCorrectionChanged();
 
@@ -178,8 +175,8 @@
     /**
     @brief
-        Called by the GraphicsManager whenever the window size changes.
+        Called by the GraphicsEngine whenever the window size changes.
         Calculates the aspect ratio only.
     */
-    void OrxonoxOverlay::windowResized(unsigned int newWidth, unsigned int newHeight)
+    void OrxonoxOverlay::windowResized(int newWidth, int newHeight)
     {
         this->windowAspectRatio_ = newWidth/(float)newHeight;
Index: code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.h
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/OrxonoxOverlay.h	(revision 2908)
@@ -154,5 +154,5 @@
         virtual void changedVisibility();
 
-        inline void setOwner(BaseObject* owner)
+        inline void setOwner(ControllableEntity* owner)
         {
             if (this->owner_ != owner)
@@ -162,5 +162,5 @@
             }
         }
-        inline BaseObject* getOwner() const
+        inline ControllableEntity* getOwner() const
             { return this->owner_; }
         virtual void changedOwner() {}
@@ -200,5 +200,5 @@
 
     private:
-        void windowResized(unsigned int newWidth, unsigned int newHeight);
+        void windowResized(int newWidth, int newHeight);
 
         static unsigned int hudOverlayCounter_s;   //!< Static counter for hud elements
@@ -206,5 +206,5 @@
             We could also use the ObjectList, but that doesn't guarantee XMLPort(.) was called and is slower. */
         static std::map<std::string, OrxonoxOverlay*> overlays_s;
-        BaseObject* owner_;
+        ControllableEntity* owner_;
         OverlayGroup* group_;
   };
Index: code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.cc	(revision 2908)
@@ -63,6 +63,6 @@
     OverlayGroup::~OverlayGroup()
     {
-        for (std::set<OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
-            delete (*it);
+        for (std::map<std::string, OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
+            delete it->second;
     }
 
@@ -83,17 +83,17 @@
     }
 
-    //! Scales every element in the set.
+    //! Scales every element in the map.
     void OverlayGroup::setScale(const Vector2& scale)
     {
-        for (std::set<OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
-            (*it)->scale(scale / this->scale_);
+        for (std::map<std::string, OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
+            (*it).second->scale(scale / this->scale_);
         this->scale_ = scale;
     }
 
-    //! Scrolls every element in the set.
+    //! Scrolls every element in the map.
     void OverlayGroup::setScroll(const Vector2& scroll)
     {
-        for (std::set<OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
-            (*it)->scroll(scroll - this->scroll_);
+        for (std::map<std::string, OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
+            (*it).second->scroll(scroll - this->scroll_);
         this->scroll_ = scroll;
     }
@@ -101,5 +101,5 @@
     /**
     @brief
-        Adds an element to the set (used when loading with XMLPort).
+        Adds an element to the map (used when loading with XMLPort).
     @remarks
         The names of the OrxonoxOverlays have to be unique!
@@ -107,21 +107,44 @@
     void OverlayGroup::addElement(OrxonoxOverlay* element)
     {
-        hudElements_.insert(element);
-        element->setVisible(this->isVisible());
-        if (this->owner_)
-            element->setOwner(this->owner_);
-    }
-
-    /**
+        this->insertElement(element, element->getName());
+    }
+
+	/**
+    @brief
+        Adds an element to the map.
+    @param element
+        The element to be added.
+    @param name
+        The name of the element.
+    @remarks
+        The names of the OrxonoxOverlays have to be unique!
+    */
+    void OverlayGroup::insertElement(OrxonoxOverlay* element, const std::string & name)
+    {
+        element->setName(name);
+        if (hudElements_.find(name) != hudElements_.end())
+        {
+            COUT(1) << "Ambiguous names encountered while load the HUD overlays" << std::endl;
+        }
+        else
+        {
+            hudElements_[name] = element;
+            element->setVisible(this->isVisible());
+			if (this->owner_)
+                element->setOwner(this->owner_);
+        }
+    }
+
+	/**
     @brief
         Removes an element from the map.
-    @param element
-        The element that is to be removed.
+    @param name
+        The name of the element that is removed.
     @return
         Returns true if there was such an element to remove, false if not.
     */
-    bool OverlayGroup::removeElement(OrxonoxOverlay* element)
-    {
-        if(this->hudElements_.erase(element) == 0)
+    bool OverlayGroup::removeElement(const std::string & name)
+    {
+        if(this->hudElements_.erase(name) == 0)
             return false;
         return true;
@@ -133,8 +156,8 @@
         if (index < this->hudElements_.size())
         {
-            std::set<OrxonoxOverlay*>::const_iterator it = hudElements_.begin();
+            std::map<std::string, OrxonoxOverlay*>::const_iterator it = hudElements_.begin();
             for (unsigned int i = 0; i != index; ++it, ++i)
                 ;
-            return (*it);
+            return (*it).second;
         }
         else
@@ -145,14 +168,14 @@
     void OverlayGroup::changedVisibility()
     {
-        for (std::set<OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
-            (*it)->setVisible(this->isVisible());
-    }
-
-    void OverlayGroup::setOwner(BaseObject* owner)
+        for (std::map<std::string, OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
+            (*it).second->setVisible(this->isVisible());
+    }
+
+    void OverlayGroup::setOwner(ControllableEntity* owner)
     {
         this->owner_ = owner;
 
-        for (std::set<OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
-            (*it)->setOwner(owner);
+        for (std::map<std::string, OrxonoxOverlay*>::iterator it = hudElements_.begin(); it != hudElements_.end(); ++it)
+            (*it).second->setOwner(owner);
     }
 
Index: code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.h
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/OverlayGroup.h	(revision 2908)
@@ -37,6 +37,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include <set>
-#include <string>
+#include <map>
 #include <OgrePrerequisites.h>
 #include "core/BaseObject.h"
@@ -65,11 +64,11 @@
         static void scrollGroup(const std::string& name, const Vector2& scroll);
 
-        inline const std::set<OrxonoxOverlay*>& getOverlays() const
+        inline const std::map<std::string, OrxonoxOverlay*>& getOverlays() const
             { return this->hudElements_; }
 
         void changedVisibility();
 
-        void setOwner(BaseObject* owner);
-        inline BaseObject* getOwner() const
+        void setOwner(ControllableEntity* owner);
+        inline ControllableEntity* getOwner() const
             { return this->owner_; }
 
@@ -87,12 +86,13 @@
 
         void addElement(OrxonoxOverlay* element);
-        bool removeElement(OrxonoxOverlay* element);
+		void insertElement(OrxonoxOverlay* element, const std::string & name);
+        bool removeElement(const std::string & name);
         OrxonoxOverlay* getElement(unsigned int index);
 
     private:
-        std::set<OrxonoxOverlay*> hudElements_;    //!< Contains all the OrxonoxOverlays of the this group.
-        Vector2 scale_;                            //!< Current scale (independent of the elements).
-        Vector2 scroll_;                           //!< Current scrolling offset.
-        BaseObject* owner_;                        //!< The owner of this OverlayGroup
+        std::map<std::string, OrxonoxOverlay*> hudElements_;    //!< Contains all the OrxonoxOverlays of the this group.
+        Vector2 scale_;                                         //!< Current scale (independent of the elements).
+        Vector2 scroll_;                                        //!< Current scrolling offset.
+        ControllableEntity* owner_;                             //!< The owner of this OverlayGroup
     };
 }
Index: code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.cc	(revision 2908)
@@ -42,5 +42,4 @@
 #include "util/Convert.h"
 #include "util/Debug.h"
-#include "core/Clock.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
@@ -173,5 +172,5 @@
     {
         // create the corresponding input state
-        inputState_ = InputManager::getInstance().createInputState<SimpleInputState>("console", false, false, InputStatePriority::Console);
+        inputState_ = InputManager::getInstance().createInputState<SimpleInputState>("console", 40);
         inputState_->setKeyHandler(Shell::getInstance().getInputBuffer());
         bHidesAllInputChanged();
@@ -348,5 +347,5 @@
         @brief Used to control the actual scrolling and the cursor.
     */
-    void InGameConsole::update(const Clock& time)
+    void InGameConsole::tick(float dt)
     {
         if (this->scroll_ != 0)
@@ -359,5 +358,5 @@
                 // enlarge oldTop a little bit so that this exponential function
                 // reaches 0 before infinite time has passed...
-                float deltaScroll = (oldTop - 0.01) * time.getDeltaTime() * this->scrollSpeed_;
+                float deltaScroll = (oldTop - 0.01) * dt * this->scrollSpeed_;
                 if (oldTop - deltaScroll >= 0)
                 {
@@ -374,5 +373,5 @@
                 // scrolling up
                 // note: +0.01 for the same reason as when scrolling down
-                float deltaScroll = (1.2 * this->relativeHeight + 0.01 + oldTop) * time.getDeltaTime() * this->scrollSpeed_;
+                float deltaScroll = (1.2 * this->relativeHeight + 0.01 + oldTop) * dt * this->scrollSpeed_;
                 if (oldTop - deltaScroll <= -1.2 * this->relativeHeight)
                 {
@@ -389,5 +388,5 @@
         if (this->bActive_)
         {
-            this->cursor_ += time.getDeltaTime();
+            this->cursor_ += dt;
             if (this->cursor_ >= this->blinkTime)
             {
@@ -410,5 +409,5 @@
         @brief Resizes the console elements. Call if window size changes.
     */
-    void InGameConsole::windowResized(unsigned int newWidth, unsigned int newHeight)
+    void InGameConsole::windowResized(int newWidth, int newHeight)
     {
         this->windowW_ = newWidth;
Index: code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.h
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/console/InGameConsole.h	(revision 2908)
@@ -53,5 +53,5 @@
         void setConfigValues();
 
-        void update(const Clock& time);
+        virtual void tick(float dt);
 
         static InGameConsole& getInstance() { assert(singletonRef_s); return *singletonRef_s; }
@@ -81,5 +81,5 @@
         void print(const std::string& text, int index, bool alwaysShift = false);
 
-        void windowResized(unsigned int newWidth, unsigned int newHeight);
+        void windowResized(int newWidth, int newHeight);
 
         // config value related
Index: code/branches/questsystem5/src/orxonox/overlays/debug/DebugFPSText.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2908)
@@ -30,7 +30,7 @@
 #include "DebugFPSText.h"
 #include <OgreTextAreaOverlayElement.h>
+#include "core/CoreIncludes.h"
+#include "GraphicsEngine.h"
 #include "util/Convert.h"
-#include "core/CoreIncludes.h"
-#include "core/Game.h"
 
 namespace orxonox
@@ -51,5 +51,5 @@
         SUPER(DebugFPSText, tick, dt);
 
-        float fps = Game::getInstance().getAvgFPS();
+        float fps = GraphicsEngine::getInstance().getAverageFramesPerSecond();
         this->setCaption(convertToString(fps));
     }
Index: code/branches/questsystem5/src/orxonox/overlays/debug/DebugRTRText.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2908)
@@ -32,5 +32,5 @@
 #include "core/CoreIncludes.h"
 #include "util/Convert.h"
-#include "core/Game.h"
+#include "GraphicsEngine.h"
 
 namespace orxonox
@@ -51,5 +51,5 @@
         SUPER(DebugRTRText, tick, dt);
 
-        float rtr = Game::getInstance().getAvgTickTime();
+        float rtr = GraphicsEngine::getInstance().getAverageTickTime();
         this->setCaption(convertToString(rtr));
     }
Index: code/branches/questsystem5/src/orxonox/overlays/hud/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/hud/CMakeLists.txt	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/hud/CMakeLists.txt	(revision 2908)
@@ -7,4 +7,3 @@
   ChatOverlay.cc
   GametypeStatus.cc
-  PongScore.cc
 )
Index: code/branches/questsystem5/src/orxonox/overlays/hud/HUDRadar.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/hud/HUDRadar.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/hud/HUDRadar.cc	(revision 2908)
@@ -94,5 +94,5 @@
     void HUDRadar::displayObject(RadarViewable* object, bool bIsMarked)
     {
-        if (object == static_cast<RadarViewable*>(this->owner_))
+        if (object == (RadarViewable*)this->owner_)
             return;
 
Index: code/branches/questsystem5/src/orxonox/overlays/notifications/NotificationQueue.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/overlays/notifications/NotificationQueue.cc	(revision 2908)
@@ -410,5 +410,5 @@
         this->containers_.insert(container);
         this->overlays_[notification] = container;
-        this->addElement(container->overlay);
+        this->insertElement(container->overlay, container->name);
         this->size_= this->size_+1;
 
@@ -429,5 +429,5 @@
             return false;
         
-        this->removeElement(container->overlay);
+        this->removeElement(container->name);
         this->containers_.erase(container);
         this->overlays_.erase(container->notification);
Index: code/branches/questsystem5/src/orxonox/pch/havepch/OrxonoxStableHeaders.h
===================================================================
--- code/branches/questsystem5/src/orxonox/pch/havepch/OrxonoxStableHeaders.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/pch/havepch/OrxonoxStableHeaders.h	(revision 2908)
@@ -45,7 +45,5 @@
 #  define WIN32_LEAN_AND_MEAN
 #endif
-#ifndef NOMINMAX
-#  define NOMINMAX // required to stop windows.h screwing up std::min definition
-#endif
+#define NOMINMAX // required to stop windows.h screwing up std::min definition
 #include <Ogre.h>
 #include <CEGUI.h>
Index: code/branches/questsystem5/src/orxonox/tools/BillboardSet.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/tools/BillboardSet.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/tools/BillboardSet.cc	(revision 2908)
@@ -37,5 +37,5 @@
 #include <OgreBillboard.h>
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "util/Convert.h"
 #include "util/String.h"
@@ -72,5 +72,5 @@
         try
         {
-            if (GameMode::showsGraphics())
+            if (Core::showsGraphics())
             {
                 this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + convertToString(BillboardSet::billboardSetCounter_s++), count);
@@ -95,5 +95,5 @@
         try
         {
-            if (GameMode::showsGraphics())
+            if (Core::showsGraphics())
             {
                 this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + convertToString(BillboardSet::billboardSetCounter_s++), count);
Index: code/branches/questsystem5/src/orxonox/tools/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/tools/CMakeLists.txt	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/tools/CMakeLists.txt	(revision 2908)
@@ -5,5 +5,4 @@
   Shader.cc
   TextureGenerator.cc
-  TimeFactorListener.cc
   Timer.cc
   WindowEventListener.cc
Index: code/branches/questsystem5/src/orxonox/tools/Mesh.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/tools/Mesh.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/tools/Mesh.cc	(revision 2908)
@@ -35,5 +35,5 @@
 #include <cassert>
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "util/Convert.h"
 #include "util/String.h"
@@ -64,5 +64,5 @@
             this->scenemanager_->destroyEntity(this->entity_);
 
-        if (GameMode::showsGraphics())
+        if (Core::showsGraphics())
         {
             try
@@ -70,13 +70,4 @@
                 this->entity_ = this->scenemanager_->createEntity("Mesh" + convertToString(Mesh::meshCounter_s++), meshsource);
                 this->entity_->setCastShadows(this->bCastShadows_);
-
-                this->entity_->setNormaliseNormals(true);
-                /*
-                    Excerpt from Ogre forum:
-                    "Note that the above is only for the fixed function pipeline.
-                    If/when you get into shaders, you'll need to manually normalize() the normal inside the vertex or pixel shader."
-
-                    I don't know exactly what this means, but I put this here if there will be problems with shaders.
-                */
             }
             catch (...)
